/* 	table.h   Revision 2.0  8/23/95                          */

/* This software was written by Symbios Logic Inc. to develop and test new
 * products.  Symbios Logic assumes no liability for its use.  This software
 * is released to the public domain to illustrate certain programming
 * techniques for the 53c720 in target mode.
 *
 */

/*
 * Revision 2.0 8/23/95  Scott Rawlings
 * Altered structure and added table entries to work with target code.
 *
 * Revision 1.2 91/06/10  15:00:06  wscott
 * Moved DATA_ADR to end of table so that it can grow.
 * Added comments.
 *
 * Revision 1.1 91/05/30  08:56:01  wscott
 * Initial revision
 *
 */

/* The following definition setup a table that can be used with the c720
 * table indirect addressing mode.  Each entry in the table is a pair of
 * 32-bit values. (The byte count and the address)  For the script to work
 * correctly the table MUST start on a word boundry and the offset labels
 * must be in the same order in the script. */

enum offsets {
    msg_out_buf = 0,
    cmd_buf,
    synch_neg_msg_out,
    wide_neg_msg_out,
    neg_msg_in,
    stat_buf,
	 identify_msg_in_buf,
	 msg_in_buf,
	 data_buf,
	 save_pointers,
	 disconnect_msg,
	 selector_id,
	 sense_data_buf,
	 inquiry_data_buf,
	 capacity_data_buf,
	 TABLE_SIZE
};

struct _table {
	 unsigned long   count;
	 unsigned long   address;
};

typedef struct _table table;

extern table   *buffer_table;
extern table   *dummy_table;
