/*      tools_lm.c   Revision 2.1 8/23/95                      */

/* This software was written by Symbios Logic Inc. to develop and test new
 * products.  Symbios Logic assumes no liability for its use.  This software
 * is released to the public domain to illustrate certain programming
 * techniques for the 53c720 in target mode.
 *
 */

/*
 * Revision 2.2 8/23/95  Scott Rawlings
 * Removed print_buffer function.
 *
 * Revision 2.1 10/1/94  Linda Miquelon / Suresh Sethuraman
 * Altered my_malloc for better functionality.
 *
 * Revision 2.0 1/1/93 GJ
 * Added support for the latest 53C720 chips, 609-3400534 and 609-0391071.
 *
 * $Log:        tools.c $
 * Revision 1.5  91/06/24  09:10:09  wscott
 * Added my_malloc which checks if malloc worked.
 *
 * Revision 1.4  91/06/11  10:19:17  wscott
 * Moved print_buffer from os.c to here.
 *
 * Revision 1.3  91/05/30  11:49:38  wscott
 * Added more clarifing comments
 *
 * Revision 1.2  91/05/30  09:41:01  wscott
 * Added version flag
 *
 * Revision 1.1  91/05/30  08:56:08  wscott
 * Initial revision
 *
 */

#include <dos.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>

#include "types.h"
#include "tools.h"

/* This function is used to copy a 32-bit value into a register. The AT only
 * allows 8 or 16-bit transfers and the c720 only allows 8 or 32-bit
 * transfers, so the value is copied in one byte at a time. */
void
write_long_reg(int reg, uquad addr)
{
    int             i;
    extern volatile ubyte far *siop_reg;

    for (i = 0; i < 4; i++)
     siop_reg[reg + i] = (addr >> 8 * i) & 0xff;
}

/* This function returns the physical 20-bit addres to a far pointer that is
 * passed.  This is needed because the c720 only understands true addresses,
 * not segment:offset. */
uquad
getPhysAddr(void far * addr)
{
   return (((uquad)FP_SEG(addr) << 4) + FP_OFF(addr));
}

void           *
my_malloc(size_t size)
{
    ubyte           *block;

    block = malloc(size+3);
 /* To fix
 */

    if (block == NULL) {
	printf("Out of memory\n");
	exit(1);
    }
    switch(FP_OFF(block)&0x03)
    {
    case 0 : break;
    case 1 : (char *)block = (char *)block + 3;
	     break;
    case 2 : (char *)block = (char *)block + 2;
	     break;
    case 3 : (char *)block = (char *)block + 1;
	     break;
    default : printf("This should never happen - Linda Miquelon\n");
    }

    return(block);
}
